// onewire.h
/*
 * J.Piwowarczyk
 * materiały dydaktyczne
 *
 */

#ifndef __ONEWIRE_H
#define __ONEWIRE_H

//#define USE_FULL_LL_DRIVER
#include "stm32f4xx_ll_gpio.h"

#define OneWire_Pin  GPIO_PIN_6
#define OneWire_Port GPIOF

typedef enum
{
  OneWire_RESET = 0,
  OneWire_SET   = 1
}OneWireState;

//typedef uint8_t[8] OneWire_ROM;

void  delayUS(volatile uint32_t usek);

void OneWire_Init(void);

void OneWire_SetInput(void);
void OneWire_SetOutput(void);
void OneWire_SetBus(void);
void OneWire_ResetBus(void);
OneWireState OneWire_GetBus(void);

uint8_t OneWire_Reset(void);
void OneWire_WriteBit(uint8_t bit);
uint8_t OneWire_ReadBit(void);
void OneWire_WriteByte(uint8_t byt);
uint8_t OneWire_ReadByte(void);

float OneWire_GetTemperature(void);
uint8_t  OneWire_GetROM(uint8_t* daneROM);
void OneWire_Set10BitsRes(void);

#endif //__ONEWIRE_H
